module Commands where

import List (intersperse)

data Command = C { bid :: Integer , action :: Action }

data Action
    = Move Direction
    | Pick [PackageID]
    | Drop [PackageID]
    | Appear Int Int
   deriving ( Eq )

nop :: Action
nop = Drop []

data Direction
    = North
    | South
    | East
    | West
  deriving ( Eq )

type PackageID = Int
type RobotID = Int

instance Show Command where
  show comm = show (bid comm) ++ " " ++ show (action comm)

instance Show Action where
  show (Move d) = "Move " ++ show d
  show (Pick pids) = "Pick" ++ showPids pids
  show (Drop pids) = "Drop" ++ showPids pids
  show (Appear x y) = "X " ++ show x ++ " Y " ++ show y

showPids pids = concatMap (\pid -> ' ' : show pid) pids

instance Show Direction where
  show North = "N"
  show South = "S"
  show East  = "E"
  show West  = "W"
