module DeliverStrategy where

import Board
import Robot
import Strategy
import GameState
import Maybe
import List
import Commands

deliverStrategy :: Rob (Maybe Command)
deliverStrategy =
  inspect (stateR & shortestR) $ \(s, shortest) -> 
       if null (myPacks s)
          then Nothing
          else 
               let candidates = 
                     sortBy (\ (_, apen,_,_)
                               (_, bpen,_,_) ->
                               compare apen bpen) $
                     foldr (\ (id, m) b ->
                              maybe b
                                    (\ (pen,path) -> 
                                       (id,pen,path,length path):b) m
                            ) [] $
                     map (\p -> (pid p,shortest (packPos p))) $
                     myPacks s
                   deliver = map fst4 $
                             filter ((==0).fth) candidates
               in case (candidates,deliver) of
                   ([],_) -> Nothing
                   (c,[]) -> let dir = thd $ head c
                             in if null dir
                                   then Nothing
                                   else Just (C 1 (Move (head dir)))
                   (_,d)  -> Just (C 1 (Drop d))

fst4 (a,_,_,_) = a
thd (_,_,c,_) = c
fth (_,_,_,d) = d
