module DetourStrategy where

import Board
import Commands
import Strategy
import Robot
import List
import GameState
import Data.FiniteMap
import Maybe

detourStrategy =
  inspect (stateR & shortestR) $ \(s, shortest) ->
    if myCapacity s <= 1
       then Nothing
       else 
    let c = 5
	m = 3
        pos = myPos s
        closest a b = compare (abs (dist pos a))
			      (abs (dist pos b))
        cpackCands = sortBy (\a b -> closest (fst a) (fst b))
                            (eltsFM $ certainPacks s)
	cpacks = getBest $ removeHomeBase s $
                 map (\ (pos,pack) -> (shortest pos, pos, pack)) (cpackCands)
	mpacks = getBest $ removeHomeBase s $
                 map (\ pos -> (shortest pos, pos, undefined)) $
                 sortBy closest (eltsFM $ maybePacks s)
    in case (cpacks,mpacks) of
         (((pen,tour),_,pack):_,_) | pen <= c && pw pack < wholeCapacity s
                                 -> takeTour tour
         (_,((pen,tour),_,_):_) | pen <= m -> takeTour tour
         _ -> Nothing

takeTour [] = Nothing
takeTour (d:_) = Just (C 1 (Move d))

notHomeBase s p = board s ? p /= Base

removeHomeBase s (l@(_,pos,_):ls) = if board s ? pos == Base
				    then removeHomeBase s ls
				    else l : removeHomeBase s ls
removeHomeBase s [] = []

getBest ((sh,pos,pack):ls)
    = case sh of
        Nothing -> getBest ls
	Just d -> (d,pos,pack) : getBest ls
getBest [] = []

                           
