module ExploreStrategy where

import Robot
import Commands
import GameState
import Strategy
import Board

import Data.FiniteMap
import Maybe( listToMaybe, fromMaybe )
import List( sort, nub )

exploreStrategy :: Rob Command
exploreStrategy =
  inspect (walkToR nearestInterestingPos & randomWalkR) $ \(comm1, comm2) ->
    if action comm1 == nop then comm2 else comm1

nearestInterestingPos :: Rob (Maybe Pos)
nearestInterestingPos =
  inspect (stateR & shortestR) $ \(s, short) ->
    listToMaybe $
      map snd $
        sort $
          [ (n,pos)
          | pos        <- nub (notVisitedHomeBases s
                       ++ map fst (eltsFM (certainPacks s)))
                       +?+ eltsFM (maybePacks s)
          , Just (n,_) <- [short pos]
          ]
 where
  [] +?+ ys = ys
  xs +?+ _  = xs
  
