module SafetyStrategy where

import Robot
import Commands
import GameState
import Strategy
import Board

import Data.FiniteMap
import Maybe( listToMaybe )
import List( sort, group )

safetyStrategy :: Rob Command -> Rob Command
safetyStrategy normal =
  normal `switch`
    repeatedBehavior ==> \badness ->
      (bidding 3 `fmap` randomWalkR) `switch`
        after badness .=> safetyStrategy normal

repeatedBehavior :: Rob (Maybe Int)
repeatedBehavior =
  let granularity = 8
      precision   = 2
      k           = granularity `div` precision
  
      watch bad ss =
        getState (\s ->
          let ss' = s:ss in
            shift (alarm bad ss') (watch (k `max` (bad-1)) (take granularity ss'))
        )
      
      alarm bad ss
        | n >= k    = Just bad
        | otherwise = Nothing
       where
        n = maximum (map length (group (sort (map myPos ss))))
   
   in watch (granularity + 2*k) []


lethalDanger :: Rob Bool
lethalDanger = undefined
